local _, MAX_HONOR = GetHonorCurrency();
local quest_itemNames = {};
local quest_itemReqNum = {};
local quest_itemNeedSlot = {};
local quest_itemTexture = {};
--
QR_Frame.CalHonorFrame = CreateFrame( "Button", "CalHonorFrame", QuestRepeatInfoFrame, "SecureActionButtonTemplate,SecureHandlerShowHideTemplate" );
local CalHonorFrame = QR_Frame.CalHonorFrame;
CalHonorFrame:Hide();
CalHonorFrame:SetWidth(180);
CalHonorFrame:SetHeight(110);
CalHonorFrame:ClearAllPoints();
CalHonorFrame:SetPoint("TOP", QuestRepeatInfoFrame, "BOTTOM", 0, -10);	
CalHonorFrame:SetClampedToScreen( true );
CalHonorFrame:SetNormalTexture( "Interface\\AchievementFrame\\UI-Achievement-Parchment-Horizontal" );
local Background = CalHonorFrame:GetNormalTexture();
Background:SetDrawLayer( "BACKGROUND" );
Background:ClearAllPoints();
Background:SetPoint( "BOTTOMLEFT", 3, 3 );
Background:SetPoint( "TOPRIGHT", -3, -3 );
Background:SetTexCoord( 0, 1, 0, 0.25 );
CalHonorFrame:SetBackdrop( {
	tile = true; edgeSize = 16;
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border";
} );

--رհť
local closeBtn = CreateFrame( "Button", nil, CalHonorFrame, "UIPanelCloseButton" );
closeBtn:SetPoint( "TOPRIGHT" );
closeBtn:SetWidth( 32 );
closeBtn:SetHeight( 32 );
closeBtn:SetScale( 0.8 );
closeBtn:SetHitRectInsets( 8, 8, 8, 8 );

--ʾ
local font_target = CalHonorFrame:CreateFontString( nil, "OVERLAY", "GameFontNormal" );
font_target:SetPoint( "TOPLEFT", CalHonorFrame, "TOPLEFT", 10, -9 );
font_target:SetText( HONOR_TARGET );

local decBtn = CreateFrame( "Button", "HonorDecrementButton", CalHonorFrame );
decBtn:SetWidth( 23 );
decBtn:SetHeight( 22 );
decBtn:SetPoint( "TOPLEFT", font_target, "BOTTOMLEFT", 25, -4 );
decBtn:SetNormalTexture( "Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Up" );
decBtn:SetPushedTexture( "Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Down" );
decBtn:SetDisabledTexture( "Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Disabled" );
decBtn:SetHighlightTexture( "Interface\\Buttons\\UI-Common-MouseHilight" );

local inputBox = CreateFrame( "EditBox", "HonorInputBox", CalHonorFrame, "InputBoxTemplate" );
inputBox:CreateFontString( nil, "OVERLAY", "ChatFontNormal" );
inputBox:SetAutoFocus( false );
inputBox:SetNumeric( true );
inputBox:SetMaxLetters( 5 );
inputBox:SetWidth( 65 );
inputBox:SetHeight( 20 );
inputBox:SetNumber(MAX_HONOR);
inputBox:SetPoint( "LEFT", decBtn, "RIGHT", 4, 0 );
inputBox:SetTextInsets(10, 0, 0, 0);

local incBtn = CreateFrame( "Button", "HonorIncrementButton", CalHonorFrame );
incBtn:SetWidth( 23 );
incBtn:SetHeight( 22 );
incBtn:SetPoint( "LEFT", inputBox, "RIGHT", 0, 0 );
incBtn:SetNormalTexture( "Interface\\Buttons\\UI-SpellbookIcon-NextPage-Up" );
incBtn:SetPushedTexture( "Interface\\Buttons\\UI-SpellbookIcon-NextPage-Down" );
incBtn:SetDisabledTexture( "Interface\\Buttons\\UI-SpellbookIcon-NextPage-Disabled" );
incBtn:SetHighlightTexture( "Interface\\Buttons\\UI-Common-MouseHilight" );

local font_need = CalHonorFrame:CreateFontString( nil, "OVERLAY", "GameFontNormal" );
font_need:SetPoint( "TOP", incBtn, "BOTTOM", 0, -2 );
font_need:SetPoint( "LEFT", CalHonorFrame, "LEFT", 10, 0 );
font_need:SetText(YOU_NEED);

local font_times = CalHonorFrame:CreateFontString( nil, "OVERLAY", "GameFontHighlight" );
font_times:SetPoint( "TOP", font_need, "BOTTOM", 0, -2 );
font_times:SetPoint( "LEFT", CalHonorFrame);
font_times:SetPoint( "RIGHT", CalHonorFrame);

local font_needMore = CalHonorFrame:CreateFontString( nil, "OVERLAY", "GameFontNormal" );
font_needMore:SetPoint( "TOP", font_times, "BOTTOM", 0, -2 );
font_needMore:SetPoint( "LEFT", CalHonorFrame, "LEFT", 10, 0 );
font_needMore:SetText(NEED_MORE);


--ֵֿĴԽ紦
function inputBox:OnTextChanged()
	local need_times = 0;
	local curHonor = g_HonorPoints;
	if (this:GetNumber() > MAX_HONOR) then
		this:SetNumber(MAX_HONOR);
	end
	local num = this:GetNumber();
	if (num > curHonor) then	
		need_times = ceil( (num - curHonor) / g_HonorReward );
		font_times:SetText(TOTAL.." "..need_times.." "..TIMES);
		for index,item in ipairs(g_QuestItems) do
			item.hadNum = Item_Check(item.name);
			item.hadSlot = floor(item.hadNum/item.reqNum);
			if(need_times > item.hadSlot)then
				quest_itemNames[index]:SetText( item.name );
				if item.maxStack ~= item.reqNum then
					quest_itemNeedSlot[index]:SetText( "X "..(need_times * item.reqNum - item.hadNum) );
				else
					quest_itemNeedSlot[index]:SetText( "X "..(need_times - item.hadSlot) );
				end
			else
				quest_itemNames[index]:SetText( item.name );
				quest_itemNeedSlot[index]:SetText( "X 0" );
			end
		end
	else
		font_times:SetText(TOTAL.." 0 "..TIMES);
		for index,item in ipairs(g_QuestItems) do
			quest_itemNames[index]:SetText( item.name );
			quest_itemNeedSlot[index]:SetText( "X 0" );
		end
	end
	
end

--ֵ'<'ť
function decBtn:OnMouseDown()
	local num = inputBox:GetNumber();
	if num <= g_HonorPoints then
		inputBox:SetNumber(g_HonorPoints);
	else
		inputBox:SetNumber(num - 1);
	end
end

--ֵ'>'ť
function incBtn:OnMouseDown()
	local num = inputBox:GetNumber();
	if num < g_HonorPoints then
		inputBox:SetNumber(g_HonorPoints);
	elseif (num < MAX_HONOR) then
		inputBox:SetNumber(num + 1);
	end
end

function CalHonorFrame:OnShow()
	local preNum = inputBox:GetNumber();
	inputBox:SetNumber(1);
	inputBox:SetNumber(preNum);--ˢ
	for index,item in ipairs(g_QuestItems) do
		if (quest_itemTexture[index] == nil) then
		quest_itemTexture[index] = CalHonorFrame:CreateTexture(nil);
		end
		quest_itemTexture[index]:Show();
		quest_itemTexture[index]:SetTexture(item.texture);
		quest_itemTexture[index]:SetHeight(32);
		quest_itemTexture[index]:SetWidth(32);
		quest_itemTexture[index]:SetPoint("TOPLEFT", font_needMore, "BOTTOMLEFT", 0, -34 * (index-1) - 6)
		if (quest_itemReqNum[index] == nil) then
		quest_itemReqNum[index] = CalHonorFrame:CreateFontString( nil, "OVERLAY", "GameFontHighlight" );
		end
		quest_itemReqNum[index]:Show();
		quest_itemReqNum[index]:SetPoint( "BOTTOMRIGHT", quest_itemTexture[index], "BOTTOMRIGHT", -2, 2 );
		quest_itemReqNum[index]:SetText( item.reqNum );
				if item.maxStack ~= item.reqNum then
					quest_itemReqNum[index]:Hide();
				else
					quest_itemReqNum[index]:Show();
				end
		if (quest_itemNames[index] == nil) then
		quest_itemNames[index] = CalHonorFrame:CreateFontString( nil, "OVERLAY", "GameFontBlack" );
		end
		quest_itemNames[index]:Show();
		quest_itemNames[index]:SetWidth(90);
		quest_itemNames[index]:SetHeight(32);
		quest_itemNames[index]:SetPoint( "LEFT", quest_itemTexture[index], "RIGHT", 2, 0 );
		if (quest_itemNeedSlot[index] == nil) then
		quest_itemNeedSlot[index] = CalHonorFrame:CreateFontString( nil, "OVERLAY", "GameFontHighlight" );
		end
		quest_itemNeedSlot[index]:Show();
		quest_itemNeedSlot[index]:SetPoint( "LEFT", quest_itemNames[index], "RIGHT", 2, 0 );
		CalHonorFrame:SetHeight(this:GetHeight() + 36);
	end
end

function CalHonorFrame:OnHide()
	CalHonorFrame:SetHeight(110);
	for index = 1, table.maxn(g_QuestItems) do
		quest_itemTexture[index]:Hide();
		quest_itemReqNum[index]:Hide();
		quest_itemNames[index]:Hide();
		quest_itemNeedSlot[index]:Hide();
	end
end

CalHonorFrame:SetScript("OnShow", CalHonorFrame.OnShow);
CalHonorFrame:SetScript("OnHide", CalHonorFrame.OnHide);
inputBox:SetScript( "OnTextChanged", inputBox.OnTextChanged );
decBtn:SetScript( "OnMouseDown", decBtn.OnMouseDown );
incBtn:SetScript("OnMouseDown", incBtn.OnMouseDown );
