local quest_itemNames = {};
local quest_itemReqNum = {};
local quest_itemNeedSlot = {};
local quest_itemTexture = {};
local RepValues = { 999,21000,12000,6000,3000,3000,3000,36000 };
local RepValMin = { 42000,21000,9000,3000,0,-3000,-6000,-42000 };
local max_rep = RepValues[1];
local barMin = RepValMin[1];

--
QR_Frame.CalRepFrame = CreateFrame( "Button", "CalRepFrame", QuestRepeatInfoFrame, "SecureActionButtonTemplate,SecureHandlerShowHideTemplate" );
local CalRepFrame = QR_Frame.CalRepFrame;
CalRepFrame:Hide();
CalRepFrame:SetWidth(180);
CalRepFrame:SetHeight(145);
CalRepFrame:ClearAllPoints();
CalRepFrame:SetPoint("TOP", QuestRepeatInfoFrame, "BOTTOM", 0, -10);	
CalRepFrame:SetClampedToScreen( true );
CalRepFrame:SetNormalTexture( "Interface\\AchievementFrame\\UI-Achievement-Parchment-Horizontal" );
local Background = CalRepFrame:GetNormalTexture();
Background:SetDrawLayer( "BACKGROUND" );
Background:ClearAllPoints();
Background:SetPoint( "BOTTOMLEFT", 3, 3 );
Background:SetPoint( "TOPRIGHT", -3, -3 );
Background:SetTexCoord( 0, 1, 0, 0.25 );
CalRepFrame:SetBackdrop( {
	tile = true; edgeSize = 16;
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border";
} );

--رհť
local closeBtn = CreateFrame( "Button", nil, CalRepFrame, "UIPanelCloseButton" );
closeBtn:SetPoint( "TOPRIGHT" );
closeBtn:SetWidth( 32 );
closeBtn:SetHeight( 32 );
closeBtn:SetScale( 0.8 );
closeBtn:SetHitRectInsets( 8, 8, 8, 8 );

--ʾ
local font_target = CalRepFrame:CreateFontString( nil, "OVERLAY", "GameFontNormal" );
font_target:SetPoint( "TOPLEFT", CalRepFrame, "TOPLEFT", 10, -9 );
font_target:SetText( REP_TARGET );

local listBox = CreateFrame("Frame", "RepCalDropDownMenu", CalRepFrame, "UIDropDownMenuTemplate");
local decBtn = CreateFrame( "Button", "RepDecrementButton", CalRepFrame );
local inputBox = CreateFrame( "EditBox", "RepInputBox", CalRepFrame, "InputBoxTemplate" );
local incBtn = CreateFrame( "Button", "RepIncrementButton", CalRepFrame );

local function OnClick(self)
	UIDropDownMenu_SetSelectedID(RepCalDropDownMenu, self:GetID());
	local i = UIDropDownMenu_GetSelectedID(listBox);
	max_rep =  RepValues[i];
	barMin = RepValMin[i];
	inputBox:SetNumber(0);
	inputBox:SetNumber(max_rep);
end

local function initialize(self, level)
   local info = UIDropDownMenu_CreateInfo()
   for index = 8, g_RepStatus.standingID, -1 do
      info = UIDropDownMenu_CreateInfo();
      info.text = GetText("FACTION_STANDING_LABEL"..index, UnitSex("player"));
      info.func = OnClick;
      UIDropDownMenu_AddButton(info, level);
   end
end

UIDropDownMenu_SetWidth(RepCalDropDownMenu, 100);
UIDropDownMenu_SetButtonWidth(RepCalDropDownMenu, 100);
UIDropDownMenu_JustifyText(RepCalDropDownMenu, "LEFT");
listBox:SetPoint("TOPLEFT", font_target, "BOTTOMLEFT", -10, -2);

decBtn:SetWidth( 23 );
decBtn:SetHeight( 22 );
decBtn:SetPoint( "TOPLEFT", listBox, "BOTTOMLEFT", 15, -2 );
decBtn:SetNormalTexture( "Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Up" );
decBtn:SetPushedTexture( "Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Down" );
decBtn:SetDisabledTexture( "Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Disabled" );
decBtn:SetHighlightTexture( "Interface\\Buttons\\UI-Common-MouseHilight" );

inputBox:CreateFontString( nil, "OVERLAY", "ChatFontNormal" );
inputBox:SetAutoFocus( false );
inputBox:SetNumeric( true );
inputBox:SetMaxLetters( 5 );
inputBox:SetWidth( 65 );
inputBox:SetHeight( 20 );
inputBox:SetNumber(max_rep);
inputBox:SetPoint( "LEFT", decBtn, "RIGHT", 5, 0 );
inputBox:SetTextInsets(10, 0, 0, 0);

incBtn:SetWidth( 23 );
incBtn:SetHeight( 22 );
incBtn:SetPoint( "LEFT", inputBox, "RIGHT", 0, 0 );
incBtn:SetNormalTexture( "Interface\\Buttons\\UI-SpellbookIcon-NextPage-Up" );
incBtn:SetPushedTexture( "Interface\\Buttons\\UI-SpellbookIcon-NextPage-Down" );
incBtn:SetDisabledTexture( "Interface\\Buttons\\UI-SpellbookIcon-NextPage-Disabled" );
incBtn:SetHighlightTexture( "Interface\\Buttons\\UI-Common-MouseHilight" );

local font_need = CalRepFrame:CreateFontString( nil, "OVERLAY", "GameFontNormal" );
font_need:SetPoint( "TOP", incBtn, "BOTTOM", 0, -2 );
font_need:SetPoint( "LEFT", CalRepFrame, "LEFT", 10, 0 );
font_need:SetText(YOU_NEED);

local font_times = CalRepFrame:CreateFontString( nil, "OVERLAY", "GameFontHighlight" );
font_times:SetPoint( "TOP", font_need, "BOTTOM", 0, -2 );
font_times:SetPoint( "LEFT", CalRepFrame);
font_times:SetPoint( "RIGHT", CalRepFrame);

local font_needMore = CalRepFrame:CreateFontString( nil, "OVERLAY", "GameFontNormal" );
font_needMore:SetPoint( "TOP", font_times, "BOTTOM", 0, -2 );
font_needMore:SetPoint( "LEFT", CalRepFrame, "LEFT", 10, 0 );
font_needMore:SetText(NEED_MORE);

--ֵֿĴԽ紦
function inputBox:OnTextChanged()
	local need_times = 0;
	if (inputBox:GetNumber() > max_rep) then
		inputBox:SetNumber(max_rep);
	end
	local num = inputBox:GetNumber();
	if ( (num + barMin) > g_RepStatus.barValue) then
		need_times = ceil( (num + barMin - g_RepStatus.barValue) / g_RepStatus.repReward );
		font_times:SetText(TOTAL.." "..need_times.." "..TIMES);
		for index,item in ipairs(g_QuestItems) do
			item.hadNum = Item_Check(item.name);
			item.hadSlot = floor(item.hadNum/item.reqNum);
			if(need_times > item.hadSlot)then
				quest_itemNames[index]:SetText( item.name );
				if item.maxStack ~= item.reqNum then
					quest_itemNeedSlot[index]:SetText( "X "..(need_times * item.reqNum - item.hadNum) );
				else
					quest_itemNeedSlot[index]:SetText( "X "..(need_times - item.hadSlot) );
				end
			else
				quest_itemNames[index]:SetText( item.name );
				quest_itemNeedSlot[index]:SetText( "X 0" );
			end
		end
	else
		font_times:SetText(TOTAL.." 0 "..TIMES);
		for index,item in ipairs(g_QuestItems) do
			quest_itemNames[index]:SetText( item.name );
			quest_itemNeedSlot[index]:SetText( "X 0");
		end
	end
	
end

--ֵ'<'ť
function decBtn:OnMouseDown()
	local num = inputBox:GetNumber();
	if (num + barMin) <= g_RepStatus.barValue then
		inputBox:SetNumber(g_RepStatus.barValue - g_RepStatus.barMin);
	else
		inputBox:SetNumber(num - 1);
	end
end

--ֵ'>'ť
function incBtn:OnMouseDown()
	local num = inputBox:GetNumber();
	if (num + barMin) < g_RepStatus.barValue then
		inputBox:SetNumber(g_RepStatus.barValue - g_RepStatus.barMin);
	elseif (num < max_rep) then
		inputBox:SetNumber(num + 1);
	end
end

function CalRepFrame:OnShow()
	local dropId = UIDropDownMenu_GetSelectedID(RepCalDropDownMenu);
	if dropId == nil then
		UIDropDownMenu_Initialize(RepCalDropDownMenu, initialize);
		UIDropDownMenu_SetSelectedID(RepCalDropDownMenu, 1);
	elseif dropId > 9-g_RepStatus.standingID then
		UIDropDownMenu_SetSelectedID(RepCalDropDownMenu, 1);
		max_rep =  RepValues[1];
		barMin = RepValMin[1];
	end
	local preNum = inputBox:GetNumber();
	inputBox:SetNumber(1);
	inputBox:SetNumber(preNum);--ˢ
	for index,item in ipairs(g_QuestItems) do
		if (quest_itemTexture[index] == nil) then
		quest_itemTexture[index] = CalRepFrame:CreateTexture(nil);
		end
		quest_itemTexture[index]:Show();
		quest_itemTexture[index]:SetTexture(item.texture);
		quest_itemTexture[index]:SetHeight(32);
		quest_itemTexture[index]:SetWidth(32);
		quest_itemTexture[index]:SetPoint("TOPLEFT", font_needMore, "BOTTOMLEFT", 0, -34 * (index-1) - 6)
		if (quest_itemReqNum[index] == nil) then
		quest_itemReqNum[index] = CalRepFrame:CreateFontString( nil, "OVERLAY", "GameFontHighlight" );
		end
		quest_itemReqNum[index]:Show();
		quest_itemReqNum[index]:SetPoint( "BOTTOMRIGHT", quest_itemTexture[index], "BOTTOMRIGHT", -2, 2 );
		quest_itemReqNum[index]:SetText( item.reqNum );
				if item.maxStack ~= item.reqNum then
					quest_itemReqNum[index]:Hide();
				else
					quest_itemReqNum[index]:Show();
				end
		if (quest_itemNames[index] == nil) then
		quest_itemNames[index] = CalRepFrame:CreateFontString( nil, "OVERLAY", "GameFontBlack" );
		end
		quest_itemNames[index]:Show();
		quest_itemNames[index]:SetWidth(85);
		quest_itemNames[index]:SetHeight(32);
		quest_itemNames[index]:SetPoint( "LEFT", quest_itemTexture[index], "RIGHT", 2, 0 );
		if (quest_itemNeedSlot[index] == nil) then
		quest_itemNeedSlot[index] = CalRepFrame:CreateFontString( nil, "OVERLAY", "GameFontHighlight" );
		end
		quest_itemNeedSlot[index]:Show();
		quest_itemNeedSlot[index]:SetPoint( "LEFT", quest_itemNames[index], "RIGHT", 2, 0 );
		CalRepFrame:SetHeight(this:GetHeight() + 36);
	end
end

function CalRepFrame:OnHide()
	CalRepFrame:SetHeight(145);
	for index = 1, table.maxn(g_QuestItems) do
		quest_itemTexture[index]:Hide();
		quest_itemReqNum[index]:Hide();
		quest_itemNames[index]:Hide();
		quest_itemNeedSlot[index]:Hide();
	end
end

CalRepFrame:SetScript("OnShow", CalRepFrame.OnShow);
CalRepFrame:SetScript("OnHide", CalRepFrame.OnHide);
inputBox:SetScript( "OnTextChanged", inputBox.OnTextChanged );
decBtn:SetScript( "OnMouseDown", decBtn.OnMouseDown );
incBtn:SetScript("OnMouseDown", incBtn.OnMouseDown );
